/**
 * ModifyRequest.java
 *
 * File generated from the core::ModifyRequest uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class ModifyRequest.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ModifyRequest", propOrder = {
	"modification",
	"dn"
})
@XmlRootElement(name = "ModifyRequest")
public class ModifyRequest extends net.ihe.gazelle.hpd.DsmlMessage implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "modification", namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public List<net.ihe.gazelle.hpd.DsmlModification> modification;
	@XmlAttribute(name = "dn", required = true)
	public java.lang.String dn;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	public ModifyRequest(){
		super();
	}
	
	/**
	 * Return modification.
	 * @return modification
	 */
	public List<net.ihe.gazelle.hpd.DsmlModification> getModification() {
		if (modification == null) {
	        modification = new ArrayList<net.ihe.gazelle.hpd.DsmlModification>();
	    }
	    return modification;
	}
	
	/**
	 * Set a value to attribute modification.
	 * @param modification.
	 */
	public void setModification(List<net.ihe.gazelle.hpd.DsmlModification> modification) {
	    this.modification = modification;
	}
	
	
	
	/**
	 * Add a modification to the modification collection.
	 * @param modification_elt Element to add.
	 */
	public void addModification(net.ihe.gazelle.hpd.DsmlModification modification_elt) {
	    this.getModification().add(modification_elt);
	}
	
	/**
	 * Remove a modification to the modification collection.
	 * @param modification_elt Element to remove
	 */
	public void removeModification(net.ihe.gazelle.hpd.DsmlModification modification_elt) {
	    this.getModification().remove(modification_elt);
	}
	
	/**
	 * Return dn.
	 * @return dn
	 */
	public java.lang.String getDn() {
	    return dn;
	}
	
	/**
	 * Set a value to attribute dn.
	 * @param dn.
	 */
	public void setDn(java.lang.String dn) {
	    this.dn = dn;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "ModifyRequest").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ModifyRequest modifyRequest, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (modifyRequest != null){
   			net.ihe.gazelle.hpd.DsmlMessage.validateByModule(modifyRequest, _location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.DsmlModification modification: modifyRequest.getModification()){
					net.ihe.gazelle.hpd.DsmlModification.validateByModule(modification, _location + "/modification[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

	public void valueAttributesFromGui() {
		for (DsmlModification mod: getModification()){
			mod.setAttrValueFromGui();
		}
	}

}